#pragma once

#include "standardglobe_global.h"
#include <qvector3d.h>

/// <summary>
/// γϵ
/// </summary>
struct LLAPos {
	double _lon_deg = 0;
	double _lat_deg = 0;
	double _alt_m = 0;
};

/// <summary>
/// ϵ
/// </summary>
struct ECEFPos {
	double _x_pos = 0;
	double _y_pos = 0;
	double _z_pos = 0;
	QVector3D getVec3() const;
};

/// <summary>
/// 챱ϵ
/// </summary>
struct ENUPos {
	double _e_pos = 0;
	double _n_pos = 0;
	double _t_pos = 0;
};

/// <summary>
/// 
/// </summary>
struct PolarPos {
	double _dist_m = 0;
	double _azimuth_deg = 0;
	double _pitch_deg = 0;
};

/// <summary>
/// ׼ת
/// </summary>
class STANDARDGLOBE_EXPORT StandardGlobe
{
private:
	/// <summary>
	/// ׼ֱ
	/// </summary>
	static double _radius_m;

public:
	StandardGlobe();

	static ECEFPos llaToEcef(const LLAPos &v);
	static void getDistanceWithin(const LLAPos &base, const LLAPos &target, double dist, double azi);

};
